package cn.iocoder.yudao.module.pms.dal.mysql;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.pms.controller.admin.vo.IotInfoClassifyListReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.vo.IotInfoClassifyPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.vo.IotProductClassifyListReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.vo.IotProductClassifyPageReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.IotInfoClassifyDO;
import org.apache.ibatis.annotations.Mapper;

import java.util.Collection;
import java.util.List;

/**
 * 设备分类 Mapper
 *
 * @author 芋道源码
 */
@Mapper
public interface IotInfoClassifyMapper extends BaseMapperX<IotInfoClassifyDO> {
    default List<IotInfoClassifyDO> selectListByParentId(Collection<Long> parentIds) {
        return selectList(IotInfoClassifyDO::getParentId, parentIds);
    }
    default IotInfoClassifyDO selectByParentIdAndName(Long parentId, String name) {
        return selectOne(IotInfoClassifyDO::getParentId, parentId, IotInfoClassifyDO::getName, name);
    }
    default List<IotInfoClassifyDO> selectList(IotInfoClassifyListReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<IotInfoClassifyDO>()
                .likeIfPresent(IotInfoClassifyDO::getName, reqVO.getName())
                .eqIfPresent(IotInfoClassifyDO::getDeviceId, reqVO.getDeviceId())
                .eqIfPresent(IotInfoClassifyDO::getStatus, reqVO.getStatus()));
    }
    default Long selectCountByParentId(Long parentId) {
        return selectCount(IotInfoClassifyDO::getParentId, parentId);
    }
    default PageResult<IotInfoClassifyDO> selectPage(IotInfoClassifyPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<IotInfoClassifyDO>()
                .eqIfPresent(IotInfoClassifyDO::getParentId, reqVO.getParentId())
                .likeIfPresent(IotInfoClassifyDO::getName, reqVO.getName())
                .eqIfPresent(IotInfoClassifyDO::getSort, reqVO.getSort())
                .eqIfPresent(IotInfoClassifyDO::getStatus, reqVO.getStatus())
                .eqIfPresent(IotInfoClassifyDO::getRemark, reqVO.getRemark())
                .betweenIfPresent(IotInfoClassifyDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(IotInfoClassifyDO::getId));
    }

}
